﻿-- Author      : Nogarder
-- Create Date : 2010/7/1 16:34:28

local NPA_NameText={}
--config
local NPA_NameText_DefaultSetting={
		["NameText_Name"]=1,
		["NameText_Guild"]=0,
		["NameText_BoldHostile"]=1,
		["NameText_BoldNonHostile"]=1,
		["NameText_NameByFaction"]=1,

		["NameText_NameByClass"]=0,
		["NameText_HideGuildInInstance"]=1,

		["NameText_HideWithHealthBar"]=1,

		["NameText_Mark"]=0,
		["NameText_MarkTarget"]=1,
		["NameText_MarkFocus"]=1,
		["NameText_MarkMouseover"]=1,

		["NameText_MarkGuildMember"]=1,
		["NameText_MarkFriend"]=1,
		["NameText_MarkRaidMember"]=1,
		["NameText_MarkPartyMember"]=1,
		["NameText_MarkHideInInstance"]=1,

		["NameText_ColorTarget"]=0,
		["NameText_ColorMouseover"]=0,
		["NameText_ColorFocus"]=0,


		["NameText_MarkColorByType"]=1,
		["NameText_OnlyPlayerName"]=0,
		["NameText_HideTotemName"]=1,

		["NameText_MarkPartyAsRaid"]=0,
		["NameText_Tapped"]=0,
		["NameText_FullName"]=0,

		["NameText_ShowPortrait"]=0,
		["NameText_ShowHostilePortrait"]=1,
		["NameText_ShowNonHostilePortrait"]=1,
		["NameText_ShowPartyPortrait"]=1,
		["NameText_ShowRaidPortrait"]=1,
		["NameText_ShowGuildPortrait"]=1,
		["NameText_ShowOnlyPlayerPortrait"]=0,

		["NameText_AutoHideGuild"]=0,


		["NameText_PortraitData"]={
			OffsetX=0,
			OffsetY=-50,
			Height=40,
			Width=40,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},
	

		["NameText_TextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
		["NameText_GuildData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
		["NameText_MarkData"]={
			OffsetX=0,
			OffsetY=70,
			Height=30,
			Width=30,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\animated\\star-white@11@11@50",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1
			},

	}
local NPA_NameText_Config=NPA_NameText_DefaultSetting

function NPA_NameText:ResetConfig()
	NPA_Config["NameText"]=CopyTable(NPA_NameText_DefaultSetting)
end



-- get global functions
local pairs = pairs
local floor = floor
local table_insert = table.insert
local unpack=unpack


--main

local NPA_NameText_Frame={}


local ManageTexture=NPA_Core.TextureManager2
local ManageFont=NPA_Core.FontManager

local function NPA_NameText_OnUpdate(_,self,guid,unitdata,_,guids,frame,hostile,isplayer,default,recentUpdated,_,isfriend,isguild,isparty,israid,isinstance)
	if(NPA_NameText_Config["NameText_HideWithHealthBar"]==1)then
		local healthbar=frame["HealthBar"]
		if(not (healthbar and healthbar:IsShown()))then
			self:Hide()
			return
		end
	end

	--alpha

	if((not default) or (NPA_NameText_Config["NameText_BoldHostile"]==1 and hostile==1) or
		(NPA_NameText_Config["NameText_BoldNonHostile"]==1 and hostile~=1))then
	
		self:SetAlpha(1)
	else
		self:SetAlpha(frame:GetAlpha())
	end
	
	--nametext
	local class=frame["ClassIcon"]
	if(NPA_NameText_Config["NameText_Name"]==1 and (NPA_NameText_Config["NameText_OnlyPlayerName"]~=1 or isplayer) and
		(not (NPA_NameText_Config["NameText_HideTotem"]==1 and class and class:IsShown() and class.IsTotem==1)) )then
		local nametext=self.Name
		local text

		if(default)then
			if(NPA_NameText_Config["NameText_Tapped"]==1 and unitdata and unitdata.Tapped)then
				nametext:SetTextColor(0.5,0.5,0.5)
			elseif(NPA_NameText_Config["NameText_NameByClass"]==1 and unitdata and isplayer)then
				local color=RAID_CLASS_COLORS[unitdata.ClassMark] or {r=1,g=1,b=0}
				nametext:SetTextColor(color.r*nametext.R,color.g*nametext.G,color.b*nametext.B)
			elseif(NPA_NameText_Config["NameText_NameByFaction"]==1)then
				if(hostile==1)then
					nametext:SetTextColor(nametext.R,0,0)
				elseif(hostile==2)then
					nametext:SetTextColor(nametext.R,nametext.G,0)
				else
					nametext:SetTextColor(0,nametext.G,0)
				end
			else
				nametext:SetTextColor(default.NameText:GetTextColor())
			end

			if(NPA_NameText_Config["NameText_FullName"]==1 and unitdata and unitdata.PVPName)then
				text=unitdata.PVPName
			else
				text=default.NameText:GetText()
			end

		elseif(unitdata)then
			if(NPA_NameText_Config["NameText_Tapped"]==1 and unitdata.Tapped)then
				nametext:SetTextColor(0.5,0.5,0.5)
			elseif(NPA_NameText_Config["NameText_NameByClass"]==1 and isplayer)then
				local color=RAID_CLASS_COLORS[unitdata.ClassMark] or {r=1,g=1,b=0}
				nametext:SetTextColor(color.r*nametext.R,color.g*nametext.G,color.b*nametext.B)
			elseif(NPA_NameText_Config["NameText_NameByFaction"]==1)then
				if(unitdata.IsEnemy==1)then
					nametext:SetTextColor(nametext.R,0,0)
				elseif(unitdata.IsFriend==1)then
					nametext:SetTextColor(0,nametext.G,0)
				else
					nametext:SetTextColor(nametext.R,nametext.G,0)
				end
			else
				nametext:SetTextColor(0.5*nametext.R,0.5*nametext.G,nametext.B)
			end
			if(NPA_NameText_Config["NameText_FullName"]==1 and unitdata.PVPName)then
				text=unitdata.PVPName
			else
				text=unitdata.Name
			end
		end

		if(guid~=0 and text)then
			if((NPA_NameText_Config["NameText_ColorTarget"]==1 and guid==guids.Target) or
			   (NPA_NameText_Config["NameText_ColorMouseover"]==1 and guid==guids.Mouseover) or
			   (NPA_NameText_Config["NameText_ColorFocus"]==1 and guid==guids.Focus))then

				text="|cffffff00"..text
			end
		end

		nametext:SetText(text)
		
		nametext:Show()
	else
		self.Name:Hide()
	end

	--guild

	if(unitdata and unitdata.Guild and NPA_NameText_Config["NameText_Guild"]==1 and 
		(NPA_NameText_Config["NameText_HideGuildInInstance"]~=1 or (not isinstance)) and
		(NPA_NameText_Config["NameText_AutoHideGuild"]~=1 or frame:GetAlpha()~=1))then

		local guildtext=self.Guild
		guildtext:SetText("<"..unitdata.Guild..">")
		if(isguild)then
			guildtext:SetTextColor(0.5*guildtext.R,guildtext.G,0.5*guildtext.B)
		else
			guildtext:SetTextColor(guildtext.R,guildtext.G,guildtext.B)
		end
		guildtext:Show()
	else
		self.Guild:Hide()
	end

	--mark

	local mark=self.Mark
	if(NPA_NameText_Config["NameText_Mark"]==1 and 
		((not isinstance) or NPA_NameText_Config["NameText_MarkHideInInstance"]~=1))then
		if(NPA_NameText_Config["NameText_MarkTarget"]==1 and guid and guid==guids.Target)then
			if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
				mark:SetVertexColor(mark.R,0,0)
			else
				mark:SetVertexColor(mark.R,mark.G,mark.B)
			end
			mark:Show()
		elseif(NPA_NameText_Config["NameText_MarkMouseover"]==1 and guid and guid==guids.Mouseover)then
			if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
				mark:SetVertexColor(mark.R*0.6,mark.G*0.6,0)
			else
				mark:SetVertexColor(mark.R,mark.G,mark.B)
			end
			mark:Show()
		elseif(NPA_NameText_Config["NameText_MarkFocus"]==1 and guid and guid==guids.Focus)then
			if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
				mark:SetVertexColor(mark.R,mark.G,0)
			else
				mark:SetVertexColor(mark.R,mark.G,mark.B)
			end
			mark:Show()
		elseif(isplayer)then
			if(NPA_NameText_Config["NameText_MarkFriend"]==1 and isfriend)then
				if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
					mark:SetVertexColor(0,mark.G,mark.B)
				else
					mark:SetVertexColor(mark.R,mark.G,mark.B)
				end
				mark:Show()
			elseif(NPA_NameText_Config["NameText_MarkPartyMember"]==1 and isparty and
				(NPA_NameText_Config["NameText_MarkPartyAsRaid"]~=1 or (not israid)))then
				if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
					mark:SetVertexColor(0,0,mark.B)
				else
					mark:SetVertexColor(mark.R,mark.G,mark.B)
				end
	
				mark:Show()
			elseif(NPA_NameText_Config["NameText_MarkRaidMember"]==1 and israid)then
				if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
					mark:SetVertexColor(mark.R,0.5*mark.G,0)
				else
					mark:SetVertexColor(mark.R,mark.G,mark.B)
				end
	
				mark:Show()
			elseif(NPA_NameText_Config["NameText_MarkGuildMember"]==1 and isguild)then
				if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
					mark:SetVertexColor(0,mark.G,0)
				else
					mark:SetVertexColor(mark.R,mark.G,mark.B)
				end
	
				mark:Show()
			else
				mark:Hide()
			end
		else
			mark:Hide()
		end
	else
		mark:Hide()
	end

	if(NPA_NameText_Config["NameText_ShowPortrait"]==1 and unitdata and (isplayer or NPA_NameText_Config["NameText_ShowOnlyPlayerPortrait"]~=1))then
		if((hostile==1 and NPA_NameText_Config["NameText_ShowHostilePortrait"]==1) or 
			(hostile~=1 and NPA_NameText_Config["NameText_ShowNonHostilePortrait"]==1 and (not isparty) and (not israid) and not (isguild)) or
			(isparty and NPA_NameText_Config["NameText_ShowPartyPortrait"]==1) or
			(israid and NPA_NameText_Config["NameText_ShowRaidPortrait"]==1) or
			(isguild and NPA_NameText_Config["NameText_ShowGuildPortrait"]==1))then

			local portrait=unitdata.Portrait
			if(portrait)then
				if(not portrait.Inited)then
					ManageTexture(nil,portrait,NPA_Config["NameText"]["NameText_PortraitData"],"CENTER",self,"CENTER",2)
					portrait.Inited=1
				end
				portrait:SetPoint("CENTER",self,"CENTER",NPA_Config["NameText"]["NameText_PortraitData"].OffsetX,NPA_Config["NameText"]["NameText_PortraitData"].OffsetY)
				portrait:SetParent(self)
				self.Portrait=portrait
				portrait:Show()
			end
		elseif(self.Portrait)then
			self.Portrait:Hide()
			self.Portrait=nil
		end
	elseif(self.Portrait)then
		self.Portrait:Hide()
		self.Portrait=nil
	end

	self:SetScale(frame:GetScale())
	self:Show()
end



local function NPA_NameText_SetFrame(frame)

	frame:Hide()
	local nametext=frame.Name

	ManageFont(nil,frame.Name,NPA_NameText_Config["NameText_TextData"],"CENTER",frame,"CENTER")
	ManageFont(nil,frame.Guild,NPA_NameText_Config["NameText_GuildData"],"CENTER",frame,"CENTER")
	ManageTexture(nil,frame.Mark,NPA_NameText_Config["NameText_MarkData"],"CENTER",frame,"CENTER")

	frame.Name:Hide()
	frame.Guild:Hide()
	frame.Mark:Hide()
end



local function NPA_NameText_HookFrame(frame)
	local nametextframe=CreateFrame("Frame","NPA_NameText_LayerFrame",frame:GetParent())
	nametextframe:SetPoint("CENTER",frame,"CENTER")
	nametextframe:SetWidth(1)
	nametextframe:SetHeight(1)
	nametextframe:Show()

	nametextframe:SetFrameStrata("TOOLTIP")

	local nametext=nametextframe:CreateFontString("NPA_NameText_Name","OVERLAY",nil)
	local guildtext=nametextframe:CreateFontString("NPA_NameText_Guild","OVERLAY",nil)
	local mark=nametextframe:CreateTexture("NPA_NameText_Mark","ARTWORK",nil)

	nametextframe.Name=nametext
	nametextframe.Guild=guildtext
	nametextframe.Mark=mark
	nametextframe.Portrait=nil

	nametextframe.Parent=frame
	nametextframe:Hide()

	nametextframe:HookScript("OnHide",function(self)
		if(self.Portrait)then
			self.Portrait:Hide()
			self.Portrait=nil
		end
		end)


	table_insert(NPA_NameText_Frame,nametextframe)

	NPA_NameText_SetFrame(nametextframe)
	
	frame["NameText"]=nametextframe
	
	return framedata
end


function NPA_NameText:ApplyConfig()
	NPA_Core:CheckConfigEntry("NameText",NPA_NameText_DefaultSetting)

	NPA_NameText_Config=NPA_Config["NameText"]

	for _,frame in pairs(NPA_NameText_Frame) do
		NPA_NameText_SetFrame(frame)
	end


end


NPA_Core:AddHook("NameText",NPA_NameText_HookFrame)
NPA_Core:AddModule("NameText",NPA_NameText)
NPA_Core:HookUpdate("NameText",NPA_NameText_OnUpdate,1)